## sight 20.2.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13)

# Use new policy for 'install_name' and RPATH on macOS (use `cmake --help-policy CMP0068` for details)
cmake_policy(SET CMP0068 NEW)
# Use new policy for `FindOpenGL` to prefer GLVND by default when available on linux (use `cmake --help-policy CMP0072` for details).
cmake_policy(SET CMP0072 NEW)
# Use new policy for 'Honor visibility properties for all target types.' (use `cmake --help-policy CMP0063` for details)
cmake_policy(SET CMP0063 NEW)
# Adds support for the new IN_LIST operator.
cmake_policy(SET CMP0057 NEW)
# Use new policy to use CMAKE_CXX_STANDARD in try_compile() macro
cmake_policy(SET CMP0067 NEW)

# On Windows, if the user doesn't specify a value,
# 'CMAKE_BUILD_TYPE' is automatically initialized to 'Debug' after 'project()'.
# So we need to check this variable at this point.
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of build, options are: Debug, Release")
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug;Release")

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT CMAKE_BUILD_TYPE STREQUAL "Release")
    message(FATAL_ERROR "Invalid value for CMAKE_BUILD_TYPE: '${CMAKE_BUILD_TYPE}' (required Debug, Release)")
endif()

project (sight)

if(APPLE)
    message(WARNING "macOS is no more officially supported and complete support will be removed in sight 21.0")
endif()

enable_testing()

include(CheckVariableExists)
include(CMakeParseArguments)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/macros.cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/linux/modules)

########################################################################################################################
# User options
########################################################################################################################

option(BUILD_SDK "Build Sight as a SDK" OFF)

# Tests build / run options
set(BUILD_TESTS ON CACHE BOOL "Configures projects associated tests (<project>Test projects)")
set(TESTS_XML_OUTPUT OFF CACHE BOOL "Tests will generate an xml output, suitable for CI integration")
mark_as_advanced(TESTS_XML_OUTPUT)
set(TESTS_FILTER "" CACHE STRING "Allows to only build/run tests whose path contains the filter string.")
mark_as_advanced(TESTS_FILTER)

set(SET_API_VERSION ON)

option(ENABLE_PCH "Use pre-compiled headers to speedup the compilation" ON)
option(VERBOSE_PCH "Display debug messages to help debugging PCH" OFF)
mark_as_advanced(ENABLE_PCH)
mark_as_advanced(VERBOSE_PCH)

# QML_IMPORT_PATH allows qtCreator to find the qml modules created in our modules
set(QML_IMPORT_PATH "" CACHE STRING "Path of the Qml modules." FORCE)
mark_as_advanced(QML_IMPORT_PATH)
set( ENABLE_QML_APPLICATION OFF CACHE BOOL "Temporary Variable to set Qml or not in applications to kept old services working" )

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/PrecompiledHeader.cmake)

if(MSVC)
    if(NOT DEFINED CMAKE_PCH_COMPILER_TARGETS)
        # this will be executed in just before makefile generation
        variable_watch(CMAKE_BACKWARDS_COMPATIBILITY pch_msvc_hook)
    endif()
endif()

if(CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES ${CMAKE_BUILD_TYPE} CACHE STRING "List of supported configurations." FORCE)
endif()

set(CREATE_SUBPROJECTS OFF CACHE BOOL "Create a project for each subproject")

set(PROJECTS_TO_BUILD CACHE STRING
        "List of projects that will be configured for build.
        Leave empty to configure all projects"
    )

# Use solution folders.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY AUTOGEN_TARGETS_FOLDER automoc)

########################################################################################################################
# Warn user of install dir isn't empty
########################################################################################################################

file(GLOB_RECURSE INSTALL_DIR_CONTENT ${CMAKE_INSTALL_PREFIX}/*)
list(LENGTH INSTALL_DIR_CONTENT CONTENT)
if(NOT CONTENT EQUAL 0)
    # DIR isn't empty, warn user.
    message(WARNING "CMAKE_INSTALL_PREFIX (${CMAKE_INSTALL_PREFIX}) isn't empty, please select another folder or clean it before running install command.")
endif()

########################################################################################################################
# External libraries management
########################################################################################################################

if(UNIX AND NOT APPLE)
    option(USE_SYSTEM_LIB "Use system libraries to compile sight" OFF)
endif()

set(FWCMAKE_RESOURCE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/)

if(USE_SYSTEM_LIB)
    # Append our 'FindPackages.cmake' to CMAKE_MODULE_PATH and include BinPkgs config file
    list(APPEND CMAKE_PREFIX_PATH ${FWCMAKE_RESOURCE_PATH}/modules)
    list(APPEND CMAKE_MODULE_PATH ${FWCMAKE_RESOURCE_PATH}/modules)
    list(APPEND CMAKE_FIND_ROOT_PATH ${FWCMAKE_RESOURCE_PATH}/modules)

    # Parsing of 'fw-*.cmake' scripts. This should go away at some point if we use CMake properly
    file(GLOB LIB_CONFIGS ${FWCMAKE_RESOURCE_PATH}/modules/fw-*.cmake )
    foreach(LIB_CONFIG ${LIB_CONFIGS})
        message(STATUS "include: ${LIB_CONFIG}")
        include("${LIB_CONFIG}")
    endforeach()
else()
    option(CONAN_BUILD_MISSING "Build missing conan package automatically (experimental)" OFF)
    mark_as_advanced(CONAN_BUILD_MISSING)
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/conan/conan-deps.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/conan/conan.cmake)
endif()

########################################################################################################################
# Automatic detection of additional repositories using .sight files
########################################################################################################################
file(GLOB ADDITIONAL_REPOSITORIES_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../*/.sight ${CMAKE_CURRENT_SOURCE_DIR}/../*/.fw4spl)

foreach(REPOSITORY ${ADDITIONAL_REPOSITORIES_FILES})
    file(READ ${REPOSITORY} REPO_RAW_NAME)
    string(STRIP ${REPO_RAW_NAME} REPO_RAW_NAME)
    string(TOUPPER ${REPO_RAW_NAME} REPO_NAME)

    if(NOT ${REPO_NAME} STREQUAL "SIGHT")

        get_filename_component(REPO_DIR ${REPOSITORY} DIRECTORY)
        get_filename_component(REPO_DIR ${REPO_DIR} ABSOLUTE)

        option(BUILD_${REPO_NAME} "Enable ${REPO_NAME} repository" ON)
        list(APPEND ADDITIONAL_REPOSITORIES_OPTION BUILD_${REPO_NAME})
        list(APPEND ADDITIONAL_REPOSITORIES_NAME ${REPO_RAW_NAME})
        list(APPEND ADDITIONAL_REPOSITORIES ${REPO_DIR})
    endif()
endforeach()

# parse additional CMakeLists
if(ADDITIONAL_REPOSITORIES)
    list(LENGTH ADDITIONAL_REPOSITORIES ADDITIONAL_REPOSITORIES_LEN)

    math(EXPR ADDITIONAL_REPOSITORIES_LEN ${ADDITIONAL_REPOSITORIES_LEN}-1)
    foreach(REPO_INDEX RANGE ${ADDITIONAL_REPOSITORIES_LEN})
        list(GET ADDITIONAL_REPOSITORIES ${REPO_INDEX} ADDITIONAL_REPO)
        list(GET ADDITIONAL_REPOSITORIES_OPTION ${REPO_INDEX} ADDITIONAL_REPO_OPTION)

        if(EXISTS ${ADDITIONAL_REPO}/CMakeLists.txt AND ${ADDITIONAL_REPO_OPTION})
            get_filename_component(DIR_NAME ${ADDITIONAL_REPO} NAME)
            add_subdirectory(${ADDITIONAL_REPO} ${DIR_NAME})
        endif()
    endforeach()
endif()

########################################################################################################################
# Default paths settings for libraries, modules and resources
########################################################################################################################

if(WIN32)
    set(FW_INSTALL_PATH_SUFFIX )
    set(SIGHT_MODULE_LIB_PREFIX "${CMAKE_INSTALL_BINDIR}")
    set(SIGHT_MODULE_RC_PREFIX "${CMAKE_INSTALL_DATADIR}")
else()
    set(FW_INSTALL_PATH_SUFFIX "sight")
    set(SIGHT_MODULE_LIB_PREFIX "${CMAKE_INSTALL_LIBDIR}/${FW_INSTALL_PATH_SUFFIX}")
    set(SIGHT_MODULE_RC_PREFIX "${CMAKE_INSTALL_DATADIR}/${FW_INSTALL_PATH_SUFFIX}")
endif()

# For backward compatibility with Sight < 20.0
set(FWBUNDLE_LIB_PREFIX "${SIGHT_MODULE_LIB_PREFIX}")
set(FWBUNDLE_RC_PREFIX "${SIGHT_MODULE_RC_PREFIX}")

set(LIBRARY_OUTPUT_DIR lib/${FW_INSTALL_PATH_SUFFIX})

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIBRARY_OUTPUT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIBRARY_OUTPUT_DIR})
# Fixed path for multi-config builds (e.g. msvc)
foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
    string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
    set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/bin )
    set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${LIBRARY_OUTPUT_DIR} )
    set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${LIBRARY_OUTPUT_DIR} )
endforeach()

########################################################################################################################
# The Properties.cmake files are the entry point to scan for targets
# We really start the configure process here
########################################################################################################################
file(GLOB_RECURSE PROJECTS_PROPERTIES */Properties.cmake)

# Do the same in additional repositories
if(ADDITIONAL_REPOSITORIES)

    list(LENGTH ADDITIONAL_REPOSITORIES ADDITIONAL_REPOSITORIES_LEN)
    math(EXPR ADDITIONAL_REPOSITORIES_LEN ${ADDITIONAL_REPOSITORIES_LEN}-1)

    foreach(REPO_INDEX RANGE ${ADDITIONAL_REPOSITORIES_LEN})
        list(GET ADDITIONAL_REPOSITORIES ${REPO_INDEX} ADDITIONAL_REPO)
        list(GET ADDITIONAL_REPOSITORIES_OPTION ${REPO_INDEX} ADDITIONAL_REPO_OPTION)

        if(${ADDITIONAL_REPO_OPTION})
            list(GET ADDITIONAL_REPOSITORIES_NAME ${REPO_INDEX} ADDITIONAL_REPO_NAME)
            message(STATUS "Configuring additional repository " ${ADDITIONAL_REPO_NAME} " found in: " ${ADDITIONAL_REPO})
            file(GLOB_RECURSE ADDITIONAL_REPOSITORIES_PROPERTIES ${ADDITIONAL_REPO}/*/Properties.cmake)
            list(APPEND PROJECTS_PROPERTIES ${ADDITIONAL_REPOSITORIES_PROPERTIES})
            set(ADDITIONAL_REPOSITORIES_SOURCE_DIR "${ADDITIONAL_REPOSITORIES_SOURCE_DIR} ${ADDITIONAL_REPO}")
        endif()
    endforeach()
endif()

set(FWCONFIG_PACKAGE_LOCATION lib/cmake/sight)

unset(PROJECT_LIST)

# Parse all Properties.cmake files and populate a list of CMake variables for each projet
# to know its dependencies, requirements, version, pch usage, etc...
foreach(PROPERTIES_FILE ${PROJECTS_PROPERTIES})
    get_filename_component(PROJECT_DIR ${PROPERTIES_FILE} PATH)

    loadProperties("${PROPERTIES_FILE}")
    if(NOT NAME)
        message(FATAL_ERROR "${PROPERTIES_FILE}: Project NAME can not be empty.")
    endif()

    list(FIND DEPENDENCIES ${NAME} DEP_LOOP)
    if(DEP_LOOP GREATER -1)
        message(FATAL_ERROR "${PROPERTIES_FILE}: A project can not be its own dependency.")
    endif()

    list(FIND REQUIREMENTS ${NAME} REQ_LOOP)
    if(REQ_LOOP GREATER -1)
        message(FATAL_ERROR "${PROPERTIES_FILE}: A project can not be its own requirement.")
    endif()

    if(${NAME}_DIR)
        message(FATAL_ERROR "${PROPERTIES_FILE}: A project NAME must be unique in the workspace. ${NAME} already defined there : ${${NAME}_DIR}")
    endif()

    string( TOUPPER "${TYPE}" TYPE )

    set(${NAME}_DEPENDENCIES      "${DEPENDENCIES}")
    set(${NAME}_REQUIREMENTS      "${REQUIREMENTS}")
    set(${NAME}_DISABLE_PCH       "${DISABLE_PCH}")
    set(${NAME}_CONAN_DEPS        "${CONAN_DEPS}")
    set(${NAME}_WARNINGS_AS_ERRORS "${WARNINGS_AS_ERRORS}")
    set(${NAME}_GENERATE_OBJECT_LIB "${GENERATE_OBJECT_LIB}")

    # Get the pch target, test the existence of type variable to exclude unbuilt projects
    if(ENABLE_PCH AND TYPE AND NOT ${NAME}_DISABLE_PCH)

=== fwlauncher/CMakeLists.txt ===
fwLoadProperties()

# TODO: We should manage to get rid of this definition
target_compile_definitions(${FWPROJECT_NAME} PRIVATE SIGHT_MODULE_RC_PREFIX="${SIGHT_MODULE_RC_PREFIX}")

find_package(Boost QUIET COMPONENTS program_options REQUIRED)
fwLink(${Boost_PROGRAM_OPTIONS_LIBRARY})

=== libs/calibration/calibration3d/CMakeLists.txt ===
fwLoadProperties()

find_package(OpenCV QUIET REQUIRED COMPONENTS opencv_calib3d opencv_aruco)
target_link_libraries(${FWPROJECT_NAME} PUBLIC opencv_calib3d opencv_aruco)

find_package(FFMPEG QUIET REQUIRED)
fwForwardLink(${FFMPEG_LIBRARIES})

find_package(Qt5 QUIET COMPONENTS Test REQUIRED)
target_link_libraries(${FWPROJECT_NAME} PRIVATE Qt5::Test)

find_package(Ceres QUIET REQUIRED)
target_link_libraries(${FWPROJECT_NAME} PUBLIC ${CERES_LIBRARIES})

fwInclude(
    ${CERES_INCLUDE_DIRS}
)

=== libs/core/arDataCamp/CMakeLists.txt ===
fwLoadProperties()

message(DEPRECATION "arDataCamp library is deprecated and will be removed in sight 22.0.
It is now useless can be safely removed from requirements.")

=== libs/core/fwAtomsPatch/CMakeLists.txt ===
fwLoadProperties()

find_package(CAMP QUIET REQUIRED)
find_package(Boost QUIET COMPONENTS log log_setup REQUIRED)

fwForwardInclude(
    ${CAMP_INCLUDE_DIR}
)

fwLink(
    ${CAMP_LIBRARIES}
    ${Boost_LOG_LIBRARY}
    ${Boost_LOG_SETUP_LIBRARY}
)


target_compile_definitions(${FWPROJECT_NAME} PRIVATE "-DCAMP_COMPILATION")

=== libs/core/fwCamp/CMakeLists.txt ===
fwLoadProperties()

fwForwardInclude(
    ${CAMP_INCLUDE_DIR}
)

fwForwardLink(${CAMP_LIBRARIES})

=== libs/core/fwCore/CMakeLists.txt ===
fwLoadProperties()

target_link_libraries(${FWPROJECT_NAME} PUBLIC std::filesystem)
target_link_libraries(${FWPROJECT_NAME} PUBLIC Boost::date_time Boost::log Boost::log_setup)

=== libs/core/fwData/CMakeLists.txt ===
fwLoadProperties()

find_package(CAMP QUIET REQUIRED)

fwInclude(
    ${CAMP_INCLUDE_DIR}
)
fwLink(
    ${CAMP_LIBRARIES}
)

=== libs/core/fwDataCamp/CMakeLists.txt ===
fwLoadProperties()

message(DEPRECATION "fwDataCamp library is deprecated and will be removed in sight 22.0.
It is now useless can be safely removed from requirements.")

=== libs/core/fwDataIO/CMakeLists.txt ===
fwLoadProperties()

#racy compatibility
target_compile_definitions(${FWPROJECT_NAME} PRIVATE PRJ_NAME="${NAME}")

find_package(ZLIB QUIET REQUIRED )

fwInclude(${ZLIB_INCLUDE_DIRS})

fwLink(
    ${ZLIB_LIBRARIES}
)

=== libs/core/fwMedDataCamp/CMakeLists.txt ===
fwLoadProperties()

message(DEPRECATION "fwMedDataCamp library is deprecated and will be removed in sight 22.0.
It is now useless can be safely removed from requirements.")

=== libs/core/fwMemory/CMakeLists.txt ===
fwLoadProperties()

find_package(Boost QUIET COMPONENTS iostreams REQUIRED)

target_link_libraries(${FWPROJECT_NAME} PUBLIC Boost::iostreams)

if(CMAKE_SYSTEM_NAME MATCHES "Windows")
    #TODO write FindPsAPI ...
    target_link_libraries(${FWPROJECT_NAME} PRIVATE psapi)
endif()

=== debian/changelog ===
sight (20.2.0-2) unstable; urgency=medium

  * d/p: add new patch to fix vrrender launch. Closes: #982262

 -- Flavien Bridault <fbridault@ircad.fr>  Tue, 16 Mar 2021 20:59:58 +0000

sight (20.2.0-1) unstable; urgency=medium

  [ Nilesh Patra ]
  [Nilesh Patra]
  * New upstream version
  * Team upload.
  * debhelper-compat 13 (routine-update)
  
  [Flavien Bridault]
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * d/p/: refresh patch
  * d/rules: enable PCH (https://git.ircad.fr/sight/sight/-/issues/263)

 -- Flavien Bridault <fbridault@ircad.fr>  Tue, 15 Dec 2020 11:10:27 +0100

=== debian/control ===
Source: sight
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Flavien Bridault <fbridault@ircad.fr>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libboost-all-dev,
               zlib1g-dev,
               libexpat1-dev,
               libpng-dev,
               libtiff5-dev,
               libcppunit-dev,
               libhdf5-dev,
               libqt5opengl5-dev,
               libqt5x11extras5-dev,
               qttools5-dev,
               libvtk7-dev,
               libgdcm-dev,
               libinsighttoolkit4-dev,
               libann-dev,
               libvtkgdcm-dev,
               libvtk7-qt-dev,
               libcamp-dev,
               libglm-dev,
               xvfb,
               xauth,
               dcmtk,
               dbus-x11,
               rdfind,
               symlinks
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/sight
Vcs-Git: https://salsa.debian.org/med-team/sight.git
Homepage: https://git.ircad.fr/Sight/sight
Rules-Requires-Root: no

Package: libsight
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: fw4spl
Provides: fw4spl
Replaces: fw4spl
Description: Sight libraries
 The Surgical Image Guidance and
 Healthcare Toolkit aims to ease the creation of
 applications based on medical imaging. It includes
 various features such as 2D and 3D digital image
 processing, visualization, augmented reality and
 medical interaction simulation. It runs on many
 different environments (Windows, Linux, macOS), is
 written in C++, and features rapid interface design
 using XML files.
 .
 Sight was formerly known as FW4SPL. It was renamed
 in 2018, firstly to make its purpose clearer, and
 secondly as part of a major change in design and in
 the governance of the development team.
 .
 This package provides the shared libraries needed to
 run C++ programs that use Sight.

Package: libsight-dev
Architecture: any
Section: libdevel
Depends: libsight (= ${binary:Version}),
         libboost-all-dev,
         zlib1g-dev,
         libexpat1-dev,
         libpng-dev,
         libtiff5-dev,
         libcppunit-dev,
         libhdf5-dev,
         libqt5opengl5-dev,
         libqt5x11extras5-dev,
         qttools5-dev,
         libvtk7-dev,
         libgdcm-dev,
         libinsighttoolkit4-dev,
         libann-dev,
         libvtkgdcm-dev,
         libvtk7-qt-dev,
         libcamp-dev,
         libglm-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Sight header files
 The Surgical Image Guidance and
 Healthcare Toolkit aims to ease the creation of
 applications based on medical imaging. It includes
 various features such as 2D and 3D digital image
 processing, visualization, augmented reality and
 medical interaction simulation. It runs on many
 different environments (Windows, Linux, macOS), is
 written in C++, and features rapid interface design
 using XML files.
 .
 Sight was formerly known as FW4SPL. It was renamed
 in 2018, firstly to make its purpose clearer, and
 secondly as part of a major change in design and in
 the governance of the development team.
 .
 This package contains the development files.

Package: vrrender
Architecture: any
Depends: libsight (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: DICOM viewer
 Medical image viewer featuring negatoscope, multi-planar
 reconstruction, and volume rendering.
 .
 Many image formats are handled such as DICOM, mhd,
 inr.gz, vtk, vti,... Segmentations meshes can also
 be imported from DICOM and vtk formats, and visualized
 in mixed rendering with images.
 .
 Tools are provided to measure distances of
 structures in the image and to place landmarks.
 .
 Last, VRRender can also connect directly to a PACS, and
 then request, download or upload DICOM files.

=== debian/rules ===
#!/usr/bin/make -f

#fix the lintian "hardening" message
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE -DUSE_SYSTEM_LIB=ON -DPROJECTS_TO_BUILD="VRRender" -DPROJECTS_TO_INSTALL="VRRender" -DCMAKE_INSTALL_RPATH="/usr/lib/$(DEB_HOST_MULTIARCH)/sight" -Wno-dev -DBUILD_TESTS=OFF -DBUILD_SDK=ON -DGIT_TAG=$(DEB_VERSION_UPSTREAM) -DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "test disabled"
endif

override_dh_shlibdeps:
	dh_shlibdeps -v -l/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib/$(DEB_HOST_MULTIARCH)/sight:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/Bundles:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/gui_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/io_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/ctrlSelection_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/ioITK_0-1/

override_dh_install:
	dh_install
	sed -i -e 's@^me=.*$$@me=/usr/bin@' \
		-e 's@^rootdir=.*$$@rootdir=/usr@' \
		debian/vrrender/usr/bin/vrrender

=== debian/watch ===
version=3
https://github.com/IRCAD-IHU/sight/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## sight 21.0.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)

# Use new policy for 'install_name' and RPATH on macOS (use `cmake --help-policy CMP0068` for details)
cmake_policy(SET CMP0068 NEW)
# Use new policy for `FindOpenGL` to prefer GLVND by default when available on linux (use `cmake --help-policy CMP0072` for details).
cmake_policy(SET CMP0072 NEW)
# Use new policy for 'Honor visibility properties for all target types.' (use `cmake --help-policy CMP0063` for details)
cmake_policy(SET CMP0063 NEW)
# Adds support for the new IN_LIST operator.
cmake_policy(SET CMP0057 NEW)
# Use new policy to use CMAKE_CXX_STANDARD in try_compile() macro
cmake_policy(SET CMP0067 NEW)
# Use old policy for Documentation to add cache variables and find VTK documentation dependent packages. (Needed for doxygen..)
cmake_policy(SET CMP0106 OLD)

# On Windows, if the user doesn't specify a value,
# 'CMAKE_BUILD_TYPE' is automatically initialized to 'Debug' after 'project()'.
# So we need to check this variable at this point.
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of build, options are: Debug, Release, RelWithDebInfo")
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug;Release;RelWithDebInfo")

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT CMAKE_BUILD_TYPE STREQUAL "Release" AND NOT CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    message(FATAL_ERROR "Invalid value for CMAKE_BUILD_TYPE: '${CMAKE_BUILD_TYPE}' (required Debug, Release, RelWithDebInfo)")
endif()

project(sight 
        VERSION 21.0.0
        DESCRIPTION   "Surgical Image Guidance and Healthcare Toolkit"
        HOMEPAGE_URL  "https://git.ircad.fr/sight/sight"
)

if(APPLE)
    message(FATAL_ERROR "macOS is not supported.")
endif()

enable_testing()

include(CheckVariableExists)
include(CMakeParseArguments)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

option(SIGHT_ENABLE_PCH "Use pre-compiled headers to speedup the compilation" ON)
option(SIGHT_VERBOSE_PCH  "Display debug messages to help debugging PCH" OFF)
mark_as_advanced(SIGHT_ENABLE_PCH)
mark_as_advanced(SIGHT_VERBOSE_PCH )

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/flags.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/macros.cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/linux/modules)

# We find VTK to know its version so we can enable PCL or not
find_package(VTK CONFIG QUIET REQUIRED)

########################################################################################################################
# User options
########################################################################################################################

# Tests build / run options
set(SIGHT_BUILD_TESTS ON CACHE BOOL "Configures projects associated tests (<project>Test projects)")
set(SIGHT_TESTS_XML_OUTPUT OFF CACHE BOOL "Tests will generate an xml output, suitable for CI integration")
mark_as_advanced(SIGHT_TESTS_XML_OUTPUT)
set(SIGHT_TESTS_FILTER "" CACHE STRING "Allows to only build/run tests whose path contains the filter string.")
mark_as_advanced(SIGHT_TESTS_FILTER)

# QML_IMPORT_PATH allows qtCreator to find the qml modules created in our modules
set(QML_IMPORT_PATH "" CACHE STRING "Path of the Qml modules." FORCE)
mark_as_advanced(QML_IMPORT_PATH)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/PrecompiledHeader.cmake)

if(MSVC)
    if(NOT DEFINED CMAKE_PCH_COMPILER_TARGETS)
        # this will be executed in just before makefile generation
        variable_watch(CMAKE_BACKWARDS_COMPATIBILITY pch_msvc_hook)
    endif()
endif()

if(CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES ${CMAKE_BUILD_TYPE} CACHE STRING "List of supported configurations." FORCE)
endif()

# Use solution folders.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY AUTOGEN_TARGETS_FOLDER automoc)

# Make openvslam optional
option(SIGHT_ENABLE_OPENVSLAM "Enable OpenVSLAM" OFF)

# Make Realsense optional ()
option(SIGHT_ENABLE_REALSENSE "Enable RealSense" OFF)

########################################################################################################################
# Warn user of install dir isn't empty
########################################################################################################################

file(GLOB_RECURSE INSTALL_DIR_CONTENT ${CMAKE_INSTALL_PREFIX}/*)
list(LENGTH INSTALL_DIR_CONTENT CONTENT)
if(NOT CONTENT EQUAL 0)
    # DIR isn't empty, warn user.
    message(WARNING "CMAKE_INSTALL_PREFIX (${CMAKE_INSTALL_PREFIX}) isn't empty, please select another folder or clean it before running install command.")
endif()

########################################################################################################################
# External libraries management
########################################################################################################################

set(FWCMAKE_RESOURCE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/)

# Append our 'FindPackages.cmake' to CMAKE_MODULE_PATH
list(APPEND CMAKE_MODULE_PATH ${FWCMAKE_RESOURCE_PATH}/modules)

if(UNIX)
    list(APPEND CMAKE_PREFIX_PATH ${FWCMAKE_RESOURCE_PATH}/modules)
    
    list(APPEND CMAKE_FIND_ROOT_PATH ${FWCMAKE_RESOURCE_PATH}/modules)
    if(UNIX)
        list(APPEND CMAKE_PREFIX_PATH /usr/share/OGRE/cmake/modules)
    endif()

    set(SIGHT_EXTERNAL_LIBRARIES CACHE PATH "External libraries location")
    mark_as_advanced(SIGHT_EXTERNAL_LIBRARIES)

    # Use directly SIGHT_EXTERNAL_LIBRARIES if set, otherwise, download and install sight-deps package
    # OpenVSLAM is the only package provided by sight-deps
    if(NOT SIGHT_EXTERNAL_LIBRARIES AND SIGHT_ENABLE_OPENVSLAM)
      include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build/download_deps.cmake)
    endif()

    if(SIGHT_EXTERNAL_LIBRARIES)
        get_filename_component(ABSOLUTE_SIGHT_EXTERNAL_LIBRARIES ${SIGHT_EXTERNAL_LIBRARIES} REALPATH)
        set(SIGHT_EXTERNAL_LIBRARIES ${ABSOLUTE_SIGHT_EXTERNAL_LIBRARIES})
        unset(ABSOLUTE_SIGHT_EXTERNAL_LIBRARIES)

        list(APPEND CMAKE_PREFIX_PATH ${SIGHT_EXTERNAL_LIBRARIES})
        list(APPEND CMAKE_MODULE_PATH ${SIGHT_EXTERNAL_LIBRARIES}/lib/cmake/)
        list(APPEND CMAKE_FIND_ROOT_PATH ${SIGHT_EXTERNAL_LIBRARIES})
        # To be added into LD_LIBRARY_PATH in our "launch" scripts.
        set(SIGHT_EXTERNAL_LIBRARIES_LIB_PATH ${SIGHT_EXTERNAL_LIBRARIES}/lib/)
    endif()
endif()

# We always need CppUnit, no need to put that in subdirectories
find_package(CppUnit QUIET REQUIRED)

########################################################################################################################
# Default paths settings for libraries, modules and resources
########################################################################################################################

set(FW_INSTALL_PATH_SUFFIX "${PROJECT_NAME}")
set(SIGHT_MODULE_RC_PREFIX "${CMAKE_INSTALL_DATADIR}/${FW_INSTALL_PATH_SUFFIX}")
if(WIN32)
    set(SIGHT_MODULE_LIB_PREFIX "${CMAKE_INSTALL_BINDIR}")
else()
    set(SIGHT_MODULE_LIB_PREFIX "${CMAKE_INSTALL_LIBDIR}")
endif()

set(FWCONFIG_PACKAGE_LOCATION lib/cmake/sight)
set_property(GLOBAL PROPERTY ${PROJECT_NAME}_COMPONENTS "")

# Define the path 'FW_SIGHT_EXTERNAL_LIBRARIES_DIR' used to find external libraries required by our applications
setExternalLibrariesDir()
if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
set(SIGHT_VCPKG_ROOT_DIR "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/debug")
else()
set(SIGHT_VCPKG_ROOT_DIR "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}")
set(EXCLUDE_PATTERN ".*/debug/.*")
endif()

add_subdirectory(libs)
add_subdirectory(modules)
add_subdirectory(configs)
add_subdirectory(activities) 
add_subdirectory(utils)
add_subdirectory(apps)
add_subdirectory(tutorials)
add_subdirectory(examples)


########################################################################################################################
# Export and install targets
########################################################################################################################

# Will export COMPONENTS: list of all available components ordered by dependency (no dependency first).
sight_generate_component_list(COMPONENTS)

configure_file(${CMAKE_SOURCE_DIR}/cmake/build/sightConfig.cmake.in
               ${CMAKE_BINARY_DIR}/cmake/sightConfig.cmake @ONLY)

# Create the sightConfigVersion file
write_basic_package_version_file(
  "${CMAKE_BINARY_DIR}/cmake/sightConfigVersion.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/install/linux/safe-xvfb-run 
    ${CMAKE_CURRENT_BINARY_DIR}/bin/safe-xvfb-run
    COPYONLY
)

# Install the sightConfig.cmake and sightConfigVersion.cmake
install(
  FILES
    "${CMAKE_BINARY_DIR}/cmake/sightConfig.cmake"
    "${CMAKE_BINARY_DIR}/cmake/sightConfigVersion.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/build/macros.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/build/linux/modules/FindFilesystem.cmake"
  DESTINATION
    ${FWCONFIG_PACKAGE_LOCATION}
  COMPONENT
    dev
)

# install CppUnitConfig.cmake in a modules folder.
install( FILES "${CMAKE_SOURCE_DIR}/cmake/modules/CppUnitConfig.cmake"
    DESTINATION
      ${FWCONFIG_PACKAGE_LOCATION}/modules
    COMPONENT
      dev
  )

# Install some files needed for the build
install(
  FILES
    "${CMAKE_SOURCE_DIR}/cmake/build/configure_file.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/build/flags.cmake"
    "${FWCMAKE_RESOURCE_PATH}/build/cppunit_main.cpp"
    "${CMAKE_SOURCE_DIR}/cmake/build/config.hpp.in"
    "${CMAKE_SOURCE_DIR}/cmake/build/plugin_config.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/build/plugin_config_command.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/build/profile_config.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/build/profile.xml.in"
    "${CMAKE_SOURCE_DIR}/cmake/build/registerServices.cpp.in"
  DESTINATION
    ${FWCONFIG_PACKAGE_LOCATION}/build
  COMPONENT
    dev
)

# Install some files needed for the install
install(
  FILES
    "${CMAKE_SOURCE_DIR}/cmake/install/generic_install.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/install/get_git_rev.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/install/helper.cmake"
    "${CMAKE_SOURCE_DIR}/cmake/install/install_imported.cmake.in"
    "${CMAKE_SOURCE_DIR}/cmake/install/pre_package.cmake"
  DESTINATION
    ${FWCONFIG_PACKAGE_LOCATION}/install
  COMPONENT
    dev
)

if(WIN32)
    install(
      FILES
        "${CMAKE_SOURCE_DIR}/cmake/build/windows/template_exe.bat.in"
      DESTINATION
        ${FWCONFIG_PACKAGE_LOCATION}/build/windows
      COMPONENT
        dev
    )
    install(
      FILES
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/package.cmake"
      DESTINATION
        ${FWCONFIG_PACKAGE_LOCATION}/install/windows
      COMPONENT
        dev
    )
    install(
      FILES
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/install_plugins.cmake"
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/template.bat.in"
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/setpath.bat.in"
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/windows_fixup.cmake.in"
      DESTINATION
        ${FWCONFIG_PACKAGE_LOCATION}/install/windows
      COMPONENT
        dev
    )
    install(
      FILES
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/NSIS/NSIS.InstallOptions.ini.in"
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/NSIS/NSIS.template.in"
      DESTINATION
        ${FWCONFIG_PACKAGE_LOCATION}/install/windows/NSIS/
    )
    install(
      FILES
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/NSIS/rc/banner_nsis.bmp"
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/NSIS/rc/dialog_nsis.bmp"
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/NSIS/rc/app.ico"
        "${CMAKE_SOURCE_DIR}/cmake/install/windows/NSIS/rc/license.rtf"
      DESTINATION
        ${FWCONFIG_PACKAGE_LOCATION}/install/windows/NSIS/rc/
    )
elseif(UNIX)
    install(
      FILES
      "${CMAKE_SOURCE_DIR}/cmake/build/linux/template.sh.in"

=== apps/CMakeLists.txt ===
add_subdirectory(SightCalibrator)
add_subdirectory(dicomxplorer)
add_subdirectory(SightViewer)

=== configs/CMakeLists.txt ===
add_subdirectory(viz)
add_subdirectory(ui)

=== tutorials/CMakeLists.txt ===

add_subdirectory(xml)
add_subdirectory(cpp)
add_subdirectory(qml)

=== utils/CMakeLists.txt ===
add_subdirectory(DicomAnonymizer)
add_subdirectory(sightrun)
add_subdirectory(arucoMarker)
add_subdirectory(charucoBoard)
add_subdirectory(NetworkProxy)
add_subdirectory(VersionGenerator)
add_subdirectory(calDataGenerator)

=== activities/viz/CMakeLists.txt ===
add_subdirectory(negato)
add_subdirectory(3d)

=== apps/SightCalibrator/CMakeLists.txt ===
sight_add_target( SightCalibrator TYPE APP )

add_dependencies(SightCalibrator
                 sightrun
                 module_appXml
                 module_ui_base
                 module_ui_qt
                 module_service
                 module_sync
                 data
                 module_ui_base
                 module_ui_flaticons
                 module_ui_icons
                 module_io_atoms
                 module_io_vision
                 module_io_video
                 module_io_activity
                 module_io_igtl
                 module_activity
                 activity_navigation_calibration
                 module_data
                 module_memory
                 module_geometry_vision
                 module_geometry_base
                 module_navigation_calibration
)

if(SIGHT_ENABLE_REALSENSE)
    add_dependencies( SightCalibrator module_io_realsense)
endif()

moduleParam(module_ui_qt
    PARAM_LIST
        resource
        stylesheet
    PARAM_VALUES
        sight::module::ui::qt/flatdark.rcc
        sight::module::ui::qt/flatdark.qss
) # Allow dark theme via module_ui_qt
moduleParam(
        module_appXml
    PARAM_LIST
        config parameters
    PARAM_VALUES
        SightCalibrator_AppCfg SightCalibrator_AppCfgParam
) # Main application's configuration to launch

sight_generate_profile(SightCalibrator)

=== apps/SightViewer/CMakeLists.txt ===
sight_add_target( SightViewer TYPE APP )


add_dependencies(SightViewer 
                 sightrun
                 module_appXml
                 module_ui_base
                 module_viz_scene3d
                 module_ui_qt
                 module_viz_scene3dQt
                 module_service
                 data
                 viz_scene2d
                 io_dimse
                 module_ui_base
                 module_ui_viz
                 module_ui_flaticons
                 module_io_vtk
                 module_io_atoms
                 module_io_dicom
                 module_viz_scene2d
                 module_data
                 module_filter_image
                 module_io_dimse
                 config_viz_scene3d
)

moduleParam(module_ui_qt
    PARAM_LIST
        resource
        stylesheet
    PARAM_VALUES
        sight::module::ui::qt/flatdark.rcc
        sight::module::ui::qt/flatdark.qss
) # Allow dark theme via module_ui_qt
moduleParam(
        module_appXml
    PARAM_LIST
        config
    PARAM_VALUES
        SightViewer_AppCfg
) # Main application's configuration to launch

sight_generate_profile(SightViewer)

=== apps/dicomxplorer/CMakeLists.txt ===
sight_add_target( dicomxplorer TYPE APP )


add_dependencies(dicomxplorer 
                 module_service
                 data
                 module_ui_base
                 module_ui_qt
                 module_activity
                 module_appXml
                 module_memory
                 sightrun
                 module_io_atoms
                 module_io_itk
                 module_io_vtk
                 module_io_dicom
                 module_io_matrix
                 module_io_activity
                 activity_io_dicom
                 activity_io_dicomweb
                 activity_viz_negato
                 activity_viz_3d
                 module_ui_icons
                 atoms
                 module_ui_base
)

moduleParam(module_appXml PARAM_LIST config parameters PARAM_VALUES dicomXplorerBase dicomXplorerAppBase)

sight_generate_profile(dicomxplorer)

=== examples/core/CMakeLists.txt ===
add_subdirectory(ExActivities)
add_subdirectory(ExDump)
add_subdirectory(ExTimeLine)

=== examples/io/CMakeLists.txt ===
add_subdirectory(ExOgreRGBDStream)
add_subdirectory(ExVideoRecorder)
add_subdirectory(ExFrameByFrame)
add_subdirectory(ExIgtl)
if(SIGHT_ENABLE_REALSENSE)
    add_subdirectory(ExRealSense)
endif()

=== libs/core/CMakeLists.txt ===
add_subdirectory(pch/pchCore)
add_subdirectory(core)
add_subdirectory(data)
add_subdirectory(pch/pchData)
add_subdirectory(activity)
add_subdirectory(service)
add_subdirectory(pch/pchService)
add_subdirectory(pch/pchServiceOmp)
add_subdirectory(atoms)
add_subdirectory(utest)
add_subdirectory(utestData)

=== debian/changelog ===
sight (21.0.0-4) unstable; urgency=medium

  * Team upload.
  [Flavien Bridault]
  * d/p/: Add patch to build with insighttoolkit5-dev
    Add patch to build with vtk9-1

  [Andreas Tille]
  * Switch (Build-)Depends from libinsighttoolkit4-dev to
    libinsighttoolkit5-dev
  * Remove trailing whitespace in debian/control (routine-update)

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 12 Jan 2022 13:43:05 +0100

sight (21.0.0-3) unstable; urgency=medium

  * Team upload
  * Calling OFListIterator(T) instead of OFIterator<T> (Closes: #1001681)

 -- Pierre Gruet <pgt@debian.org>  Wed, 15 Dec 2021 23:03:15 +0100

sight (21.0.0-2) unstable; urgency=medium

  * d/p/: Add patch to remove a service that does not build on i386
  * d/.manpages: Update manual pages to match the current version

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 03 Nov 2021 10:50:39 +0100

sight (21.0.0-1) unstable; urgency=medium

  [Flavien Bridault]
  * Rename vrrender package into sightviewer
  * Add package for sightcalibrator
  * d/p/: remove patch to fix vrrender launch, no longer needed
    Add patch to fix the loading of dynamic libraries at runtime
    Add patch to add missing stdlib includes
    Add patch to disable samples build
  * Build-Depends: qt3d5-dev, qtmultimedia5-dev, qtquickcontrols2-5-dev,
                   libarchive-dev,libfftw3-dev, libopenigtlink-dev
  * d/upstream: update github organization urls

  [Andreas Tille]
  * Team upload.
  * Fix watchfile to detect new versions on github
  * New upstream version
    Closes: #984330
  * Standards-Version: 4.6.0 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Update watch file format version to 4.
  * Versioned Build-Depends: libcamp-dev (>= 0.8.4-3)
  * Build-Depends: libopencv-dev, libceres-dev

 -- Flavien Bridault <fbridault@ircad.fr>  Thu, 21 Oct 2021 15:00:59 +0200

=== debian/control ===
--- 
+++ 
@@ -3,33 +3,39 @@
 Uploaders: Flavien Bridault <fbridault@ircad.fr>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               cmake,
+Build-Depends: cmake (>=3.19.0),
+               dcmtk,
+               debhelper-compat (= 13),
+               dbus-x11,
+               libarchive-dev,
                libboost-all-dev,
-               zlib1g-dev,
+               libcamp-dev (>= 0.8.4-3),
+               libceres-dev,
+               libcppunit-dev,
                libexpat1-dev,
-               libpng-dev,
-               libtiff5-dev,
-               libcppunit-dev,
-               libhdf5-dev,
+               libfftw3-dev,
+               libgdcm-dev,
+               libglm-dev,
+               libinsighttoolkit5-dev,
+               libogre-1.12-dev,
+               libopencv-dev,
+               libopenigtlink-dev,
                libqt5opengl5-dev,
                libqt5x11extras5-dev,
+               libvtk9-dev,
+               libvtkgdcm-dev,
+               libvtk9-qt-dev,
+               qt3d5-dev,
+               qtmultimedia5-dev,
+               qtquickcontrols2-5-dev,
                qttools5-dev,
-               libvtk7-dev,
-               libgdcm-dev,
-               libinsighttoolkit4-dev,
-               libann-dev,
-               libvtkgdcm-dev,
-               libvtk7-qt-dev,
-               libcamp-dev,
-               libglm-dev,
+               rdfind,
+               symlinks,
+               xauth,
                xvfb,
-               xauth,
-               dcmtk,
-               dbus-x11,
-               rdfind,
-               symlinks
-Standards-Version: 4.5.1
+               zlib1g-dev,
+               zstd
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/sight
 Vcs-Git: https://salsa.debian.org/med-team/sight.git
 Homepage: https://git.ircad.fr/Sight/sight
@@ -76,14 +82,15 @@
          libqt5opengl5-dev,
          libqt5x11extras5-dev,
          qttools5-dev,
-         libvtk7-dev,
+         libvtk9-dev,
          libgdcm-dev,
-         libinsighttoolkit4-dev,
+         libinsighttoolkit5-dev,
          libann-dev,
          libvtkgdcm-dev,
-         libvtk7-qt-dev,
+         libvtk9-qt-dev,
          libcamp-dev,
          libglm-dev,
+         libogre-1.12-dev,
          ${shlibs:Depends},
          ${misc:Depends}
 Description: Sight header files
@@ -104,11 +111,14 @@
  .
  This package contains the development files.
 
-Package: vrrender
+Package: sightviewer
 Architecture: any
 Depends: libsight (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
+Conflicts: vrrender
+Provides: vrrender
+Replaces: vrrender
 Description: DICOM viewer
  Medical image viewer featuring negatoscope, multi-planar
  reconstruction, and volume rendering.
@@ -121,5 +131,20 @@
  Tools are provided to measure distances of
  structures in the image and to place landmarks.
  .
- Last, VRRender can also connect directly to a PACS, and
+ Last, SightViewer can also connect directly to a PACS, and
  then request, download or upload DICOM files.
+
+Package: sightcalibrator
+Architecture: any
+Depends: libsight (= ${binary:Version}),
+         ${shlibs:Depends},
+         ${misc:Depends}
+Description: Camera calibration software
+ User-friendly application to calibrate mono and stereo cameras.
+ .
+ SightCalibrator can take images, video files, or any supported
+ camera device as input. It detects the presence of a checkboard
+ in images. The parameters of the checkboard can be customized.
+ Individual images can then be marked to be used in the
+ computation of the calibration. Last, the intrinsic and extrinsic
+ parameters can be exported in OpenCV format, Yaml or XML.

=== debian/rules ===
#!/usr/bin/make -f

#fix the lintian "hardening" message
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE -DCMAKE_INSTALL_RPATH="/usr/lib/$(DEB_HOST_MULTIARCH)/sight" -Wno-dev -DBUILD_TESTS=OFF -DBUILD_SDK=ON -DGIT_TAG=$(DEB_VERSION_UPSTREAM) -DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "test disabled"
endif

override_dh_shlibdeps:
	dh_shlibdeps -v -l/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib/$(DEB_HOST_MULTIARCH)/sight

override_dh_install:
	dh_install
	sed -i -e 's@^me=.*$$@me=/usr/bin@' \
		-e 's@^rootdir=.*$$@rootdir=/usr@' \
		debian/sightviewer/usr/bin/sightviewer

=== debian/watch ===
version=4
https://github.com/IRCAD/sight/releases .*/refs/tags/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
